//------------------------------------------------------------------
// initial version of idwma by WHRoeder
// 
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DimGray
#property indicator_color6  Yellow
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width1  2
#property indicator_level1  0

//
//
//
//
//

#import "idwma.dll"
   double iDwma(double& prices[],int length, int totalBars,int shift);
#import

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    FastPeriod   = 12;
extern int    SlowPeriod   = 26;
extern int    SignalPeriod =  9;
extern int    Price        =  0;
extern int    BarsToCount  =  0;

//
//
//
//
//

double macd[];
double macdhUu[];
double macdhUd[];
double macdhDu[];
double macdhDd[];
double signal[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,macdhUu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macdhUd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macdhDd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,macdhDu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
      int drawBegin = MathMax(MathMax(FastPeriod,SlowPeriod),SignalPeriod);
         for (int i=0; i<6; i++) SetIndexDrawBegin(i,drawBegin);

         //
         //
         //
         //
         //
         
         timeFrame         = stringToTimeFrame(TimeFrame);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

   IndicatorShortName(timeFrameToString(timeFrame)+" MACD ("+FastPeriod+","+SlowPeriod+","+SignalPeriod+")");
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double prices[],macdw[];
int start()
{
   int i,r,counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
             int limit = MathMin(Bars-counted_bars,Bars-1);
             int limic = limit;
               if (BarsToCount>0)
               {
                  limic = MathMin(limic+SignalPeriod,MathMin(Bars-1,BarsToCount*timeFrame/Period()));
                     int drawBegin = MathMax(0,Bars-BarsToCount*timeFrame/Period()-1);
                     for (i=0; i<6; i++) SetIndexDrawBegin(i,drawBegin);
               }               
               if (returnBars) { macd[0] = MathMin(limic+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (ArraySize(prices)!=Bars) { ArrayResize(prices,Bars); ArrayResize(macdw,Bars); }
      
      //
      //
      //
      //
      //
      
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         prices[r] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            if (i>limic)
            {
               macd[i] = 0;
               continue;
            }
         
         //
         //
         //
         //
         //
         
         macd[i]    = iDwma(prices,FastPeriod,Bars,i)-iDwma(prices,SlowPeriod,Bars,i); macdw[r] = macd[i];
         if (SignalPeriod>1) 
            signal[i] = iDwma(macdw,SignalPeriod,Bars,i);
         macdhUu[i] = EMPTY_VALUE;
         macdhUd[i] = EMPTY_VALUE;
         macdhDu[i] = EMPTY_VALUE;
         macdhDd[i] = EMPTY_VALUE;
         slope[i]   = slope[i+1];
            if (macd[i]>macd[i+1]) slope[i] =  1;
            if (macd[i]<macd[i+1]) slope[i] = -1;
            if (macd[i]>0)
               if (slope[i]==1)
                     macdhUu[i] = macd[i];
               else  macdhUd[i] = macd[i];
            if (macd[i]<0)
               if (slope[i]==1)
                     macdhDu[i] = macd[i];
               else  macdhDd[i] = macd[i];
      }         
      return(0);
   }

   //
   //
   //
   //
   //
   
   limic = MathMax(limic,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limic; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]); 
      macd[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastPeriod,SlowPeriod,SignalPeriod,Price,BarsToCount,4,y);
      signal[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastPeriod,SlowPeriod,SignalPeriod,Price,BarsToCount,5,y);
      macdhUu[i] = EMPTY_VALUE;
      macdhUd[i] = EMPTY_VALUE;
      macdhDu[i] = EMPTY_VALUE;
      macdhDd[i] = EMPTY_VALUE;
      slope[i]   = slope[i+1];
         if (macd[i]>macd[i+1]) slope[i] =  1;
         if (macd[i]<macd[i+1]) slope[i] = -1;
         if (macd[i]>0)
            if (slope[i]==1)
                  macdhUu[i] = macd[i];
            else  macdhUd[i] = macd[i];
         if (macd[i]<0)
            if (slope[i]==1)
                  macdhDu[i] = macd[i];
            else  macdhDd[i] = macd[i];
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}